# -*- coding: iso-8859-15 -*-

import pygtk
pygtk.require('2.0')
import gtk

from ogzBrowse import ogzBrowseColumn,ogzBrowse


class ogzBigCalendar:

    def __init__(self, oBase):
        self.oBase = oBase
        self.frame = gtk.Frame()
     #  self.scrolledWindow = gtk.ScrolledWindow()
      #  self.scrolledWindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.calend = gtk.Calendar()
        self.store = gtk.ListStore(str, object)
        self.view = gtk.TreeView(self.store)
        cell = gtk.CellRendererText()
        col = gtk.TreeViewColumn()
        
        lisBrCols = []
        lisBrCols.append( ogzBrowseColumn( "hour", str, self.cell_hour_cbfunc, None ) )
        lisBrCols.append( ogzBrowseColumn( "graph", str ) )
        lisBrCols.append( ogzBrowseColumn( "calObject", object, None, None, False) )
        
        obr = ogzBrowse(lisBrCols, "list")
        self.treeView = obr.getView()
        self.listStore = self.treeView.get_model()
        
        self.treeView.set_rubber_banding(True)
        #self.treeView.set_fixed_height_mode(True)  # Note :speeds up display        
        self.treeView.set_grid_lines(gtk.TREE_VIEW_GRID_LINES_BOTH)
        
        self.treeSelection = self.treeView.get_selection()
        self.treeSelection.set_mode(gtk.SELECTION_MULTIPLE)
        
        self.listStore.clear()
        
        
        for h in range(7,22):
            for m in range(0,60,15):
                self.listStore.append([str(h) + ":" + str(m),"",None])
        
        
       # self.scrolledWindow.add(self.calend)
       # self.frame.add(self.scrolledWindow)
        self.frame.add(self.treeView)
        
        self.treeView.connect("row-activated", self.row_activated)
        self.treeView.connect("drag-end", self.drag_motion)
        self.treeView.connect("selection-received", self.selection_received)
       # self.treeView.connect("button-press-event", self.button_press_event)
       # self.treeView.connect("button-release-event", self.button_release_event)
        self.treeView.connect("drag-data-received", self.drag_data_received)
        self.treeView.connect("drag-data-get", self.drag_data_get)
        
        self.frame.show_all()

    def cell_hour_cbfunc(self, column, cell_renderer, tree_model, path):
        hour = tree_model.get_value(path, 0)
        if (":0" in hour) or (":30" in hour):
            cell_renderer.set_property("text", hour + "--" ) 
        else:
            cell_renderer.set_property("text","   -")    


    def row_activated(self):
        print "row_activated"
        
    def drag_data_received(self):
        print "drag_data_received"
        
    def drag_data_get(self):
        print "drag_data_get"
    
    def selection_received(self):
        print "selection_received"
        
   # def button_release_event(self):
   #     print "button-release-event"        
        
   # def button_press_event(self):
   #     print "button-press-event"            
            
            
    def drag_motion (self):
        print "drab-motion"
        
