# -*- coding: iso-8859-15 -*-

import pygtk
pygtk.require('2.0')
import gtk, gobject

from ogzDialogCalendar import ogzDialogCalendar

class ogzFrameCategories:

    def __init__(self, oBase):
        self.oBase = oBase
        self.frame = gtk.Frame()
        self.treeView = gtk.TreeView()
        self.listStore = gtk.ListStore(str, gobject.TYPE_BOOLEAN)
        
        self.treeView.set_model(self.listStore)
        
        celText = gtk.CellRendererText()      # on prepare la view de la liste des categories
        celTogg = gtk.CellRendererToggle()
        celTogg.set_property('activatable', True)
        colName = gtk.TreeViewColumn('Categories')
        colTogg = gtk.TreeViewColumn('Show',celTogg)
        colTogg.add_attribute(celTogg, "active", 1)
        
        colName.pack_start(celText, False)
        colName.add_attribute(celText, 'text', 0)
        self.treeView.append_column(colTogg)        
        self.treeView.append_column(colName)
        
        self.treeSelection = self.treeView.get_selection()
        scrolledwindow = gtk.ScrolledWindow(None, None)
        scrolledwindow.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
        scrolledwindow.add(self.treeView)
        self.frame.add(scrolledwindow)
        self.display()
        celTogg.connect('toggled', self.on_celTogg_toggled, self.listStore)
        self.treeView.connect('row-activated', self.on_treeView_row_activated)
    
    
    def display(self):
        self.listStore.clear()
        for cat in self.oBase.oConf.categories.values():
            self.listStore.append([cat.name,cat.visible])
            
    def on_celTogg_toggled(self, cell, path, model):
        print path
        model[path][1] = not model[path][1]
        self.oBase.oConf.categories[model[path][0]].toggle_visible()
        #self.calendars[self.listStore[int(path)][0]].selected = model[path][2]
        self.oBase.redisplay_selected_calendars()
#        self.myTaskList.display()
    
    def get_selected(self):
        print self.treeSelection.get_selected()
        (model, iter) = self.treeSelection.get_selected()
        cat = self.listStore.get_value(iter, 0)
        return cat
    
    def on_treeView_row_activated(self, treeview, path, column):
        if column == treeview.get_column(0):
            return
        row = path[0]
        print  column
        #calendar = self.calendars[self.listStore[row][0]]
        #dialog = ogzDialogCalendar(calendar, "edit", self.oBase.oConf)
        #dialog.run()
        #self.listStore[row][1] = calendar.name #update cal name
          
        
