# -*- coding: iso-8859-15 -*-

import pygtk
pygtk.require('2.0')
import gtk
from icalendar import vText

class ogzPostIt:
    def __init__(self, oBase, task, cal):
        self.oBase = oBase
        self.task = task
        self.task["X-OGZP"] = "True"
        self.Cal = cal
        self.win = gtk.Window()
        self.win.set_decorated(False)
        self.win.set_property("skip-taskbar-hint", True)
        self.win.set_property("skip-pager-hint", True)  
        if self.task.has_key("X-OGZPWIDTH"):
            print self.task["X-OGZPWIDTH"]
            self.win.set_default_size(int(self.task["X-OGZPWIDTH"]), 164)
        else:  
            self.win.set_default_size(164,164)
        self.vbox = gtk.VBox(homogeneous=False, spacing=0)
        hbox = gtk.HBox(homogeneous=False, spacing=0)
        self.win.add(self.vbox)
        self.textview = gtk.TextView()
        self.textview.set_wrap_mode(gtk.WRAP_WORD)
        if self.task.has_key("X-OGZPCOLOR"):
            print "++",self.task["X-OGZPCOLOR"]
            self.textview.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.task["X-OGZPCOLOR"]))
        else:
            self.textview.modify_base(gtk.STATE_NORMAL, gtk.gdk.Color(65535,65535,32768))
        self.textview.get_buffer().set_text(self.task['DESCRIPTION'])
#      self.textview.modify_base(gtk.STATE_SELECTED, gtk.gdk.Color(25050,2550,64))
 #     self.textview.modify_base(gtk.STATE_ACTIVE, gtk.gdk.Color(25050,2550,64))
 #     self.textview.modify_base(gtk.STATE_PRELIGHT, gtk.gdk.Color(25050,2550,64))        
        b1 = gtk.Button()
        b1.set_relief(gtk.RELIEF_NONE)
        i = gtk.Image()
        i.set_from_stock(gtk.STOCK_PROPERTIES,gtk.ICON_SIZE_MENU) 
        b1.set_image(i)
        
        b2 = gtk.Button()
        b2.set_relief(gtk.RELIEF_NONE)
        i = gtk.Image()
        i.set_from_stock(gtk.STOCK_CLOSE,gtk.ICON_SIZE_MENU) 
        b2.set_image(i)
        l = gtk.Label()
        l.set_text("  " + task['SUMMARY'] + "  ")
        
        self.menu = gtk.Menu()
        item = gtk.CheckMenuItem("Read Only")
        item.set_active(True)
        self.postitToggleReandOnly(item)
        item.connect("activate", self.postitToggleReandOnly)
        self.menu.append(item)
        
        item = gtk.ImageMenuItem(gtk.STOCK_SELECT_COLOR)
        item.connect("activate", self.postitChooseColor)
        self.menu.append(item)
        
        
        item = gtk.CheckMenuItem("Keep Above")
        if self.task.has_key("X-OGZPKEEPABOVE"):
            item.set_active(True)
        else:
            item.set_active(False)
        self.postitToggleKeepAbove(item)
        item.connect("activate", self.postitToggleKeepAbove)
        self.menu.append(item)
        
        item = gtk.MenuItem("Send to stickies")
        item.connect("activate", self.oBase.oStickPlug.sendPostit,self.task)
        self.menu.append(item)
        
        self.menu.show_all()
        
        #hbox.pack_start(b1,expand=False, fill=True, padding=0)
        hbox.pack_start(b1,expand=False, fill=True, padding=0)
        hbox.pack_start(l,expand=True, fill=True, padding=0)
        hbox.pack_start(b2,expand=False, fill=True, padding=0)
        
        self.vbox.pack_start(hbox,expand=False, fill=True, padding=0)
        self.vbox.pack_start(self.textview,expand=True, fill=True, padding=0)
        
        b1.connect("clicked", self.postitMenu)
        b2.connect("clicked", self.postitClose)
        self.textview.connect("focus-out-event", self.test_content_changed)
        self.win.add_events(gtk.gdk.BUTTON_PRESS_MASK)
        self.win.add_events(gtk.gdk._2BUTTON_PRESS)
        self.win.connect("button-press-event", self.on_button_press)
        self.win.connect("destroy",self.winClose)
        self.win.connect("configure_event", self.configEvent)
        self.win.stick()
        self.win.set_keep_above(True)
        self.win.show_all()
    
    def winClose(self, widget):
        del self.task["X-OGZP"]
        if self.task.has_key("X-OGZPCOLOR"):
            del self.task["X-OGZPCOLOR"]
        if self.task.has_key("X-OGZPWIDTH"):
            del self.task["X-OGZPWIDTH"]         
        if self.task.has_key("X-OGZPKEEPABOVE"):            
            del self.task["X-OGZPKEEPABOVE"]   
        
        
    def postitClose(self,data):
        self.win.destroy()
        
    def postitMenu(self,data):
        self.menu.show_all()
        self.menu.popup(None,None,None,1,0)
        
    
    def postitToggleReandOnly(self, data):
        if data.get_active():
            self.textview.set_editable(False)
        else:
            self.textview.set_editable(True)
    
    def test_content_changed(self, widget, event):
        print "perte du focus du textview"
        text_buf = self.textview.get_buffer()
        new_text = text_buf.get_text(text_buf.get_start_iter(),text_buf.get_end_iter())
        if new_text !=  self.task['DESCRIPTION']:
            self.task['DESCRIPTION'] = vText(new_text)
        
    def on_button_press(self, widget, event):
		#self.appw.set_icon_geometry(self.window.get_position()[0],self.window.get_position()[1],self.window.get_size()[0],self.window.get_size()[1])
		#if event.type == gtk.gdk._2BUTTON_PRESS and event.button == 1:
		#	if self.appw.is_minimized():
		#		self.appw.unminimize(event.time)
		#	else:
		#		self.appw.minimize()
		#elif event.type == gtk.gdk.BUTTON_PRESS and event.button == 3:
		#	mnuw = wnck.create_window_action_menu(self.appw)
		#	mnuw.popup(None, None, None, event.button, event.time, event)
		if event.button == 1:
			self.win.begin_move_drag(event.button, int(event.x_root), int(event.y_root), event.time)    
        
    def postitChooseColor(self, data):
        dlg = gtk.ColorSelectionDialog("Choose background color")     
        response = dlg.run()
        color = dlg.colorsel.get_current_color()
        dlg.destroy()
        if response == gtk.RESPONSE_OK:
            self.textview.modify_base(gtk.STATE_NORMAL, color)
            self.task["X-OGZPCOLOR"] = color.to_string()
    
    def postitToggleKeepAbove(self, data):
        if data.get_active():
            self.win.set_keep_above(True)
            self.task["X-OGZPKEEPABOVE"] = "True"
        else:
            self.win.set_keep_above(False)
            if self.task.has_key("X-OGZPKEEPABOVE"):            
                del self.task["X-OGZPKEEPABOVE"]
        
            
    def configEvent(self, widget, allocation):
        width = self.win.get_size()[0]
        self.task["X-OGZPWIDTH"] = width         
        
        
        
        
        
           
        
