# -*- coding: iso-8859-15 -*-

import pygtk
pygtk.require('2.0')
import gtk

from ogzBrowse import ogzBrowseColumn,ogzBrowse


class ogzWeekCalendar:

    def __init__(self, oBase):
        self.oBase = oBase
        self.frame = gtk.Frame()
     #  self.scrolledWindow = gtk.ScrolledWindow()
      #  self.scrolledWindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.calend = gtk.Calendar()
        self.store = gtk.ListStore(str, object)
        self.view = gtk.TreeView(self.store)
        cell = gtk.CellRendererText()
        col = gtk.TreeViewColumn()
                
        lisBrCols = []
	lisBrCols.append( ogzBrowseColumn( "hour", str, self.cell_hour_cbfunc, None ) )
        lisBrCols.append( ogzBrowseColumn( "Mon", str ) )
        lisBrCols.append( ogzBrowseColumn( "Tue", str ) )
        lisBrCols.append( ogzBrowseColumn( "Wed", str ) )
        lisBrCols.append( ogzBrowseColumn( "Thu", str ) )
        lisBrCols.append( ogzBrowseColumn( "Fri", str ) )
        lisBrCols.append( ogzBrowseColumn( "Sat", str ) )
        lisBrCols.append( ogzBrowseColumn( "Sun", str ) )
       
        
        obr = ogzBrowse(lisBrCols, "list")
        self.treeView = obr.getView()
        self.listStore = self.treeView.get_model()
        
        self.treeView.set_rubber_banding(True)
       # self.treeView.set_fixed_height_mode(True)  # Note :speeds up display        
       # self.treeView.set_grid_lines(gtk.TREE_VIEW_GRID_LINES_HORIZONTAL)
        
        self.treeSelection = self.treeView.get_selection()
        self.treeSelection.set_mode(gtk.SELECTION_MULTIPLE)
        
        self.listStore.clear()
        
        
        for h in range(7,22):
            for m in range(0,60,15):
                self.listStore.append([str(h) + ":" + str(m),"","","","","","",""])
        
        
       # self.scrolledWindow.add(self.calend)
       # self.frame.add(self.scrolledWindow)
        self.frame.add(self.treeView)
        self.frame.show_all()

    def cell_hour_cbfunc(self, column, cell_renderer, tree_model, path):
        hour = tree_model.get_value(path, 0)
        if (":0" in hour) or (":30" in hour):
            cell_renderer.set_property("text", hour + "--" ) 
        else:
            cell_renderer.set_property("text","   -")    


