# -*- coding: iso-8859-15 -*-

import pygtk
pygtk.require('2.0')
import gtk, gobject

class ogzBrowseColumn:
    def __init__(self, name, dtype, cbfunc = None, properties = None, isviewed = True, signals = None):
        self.name = name
        self.dtype = dtype
        self.cbfunc = cbfunc
        self.properties = properties
        self.isviewed = isviewed
        self.signals = signals

class ogzBrowse:
    def __init__(self,columns, stype = "list"):
        cols = []
        for c in columns:
            cols.append(c.dtype)
            
            
        if stype == "list":    
            self.store = gtk.ListStore(*cols)
        elif stype == "tree":
            self.store = gtk.TreeStore(*cols)
            
        self.view = gtk.TreeView(self.store)
        
        nb = 0
        for c in columns:
            if c.isviewed:
                if c.dtype == int or c.dtype == str:
                    cell = gtk.CellRendererText()
                elif c.dtype == gobject.TYPE_BOOLEAN:
                    cell = gtk.CellRendererToggle()  
                    cell.set_property('activatable', True)  
                    
                col = gtk.TreeViewColumn(c.name, cell)
                col.set_visible(True)
                
                if c.cbfunc:
                    col.set_cell_data_func(cell, c.cbfunc)
                elif c.dtype == int or c.dtype == str:
                    col.add_attribute(cell, "text",nb)
                elif c.dtype == gobject.TYPE_BOOLEAN:
                    col.add_attribute(cell, "active", nb)    
                    
                if c.properties:    
                    for p,v in c.properties:
                        col.set_property(p, v)
                if c.signals:
                    for s,f in c.signals:
                        cell.connect(s, f, self.store)
                            
                self.view.append_column(col)
            nb = nb + 1                
                       
    def getView(self):                       
        return self.view                    
    
    
