# -*- coding: iso-8859-15 -*-

import pygtk
pygtk.require('2.0')
import gtk

from icalendar import vDatetime,vText
from datetime  import datetime

class ogzEditTask:
    def __init__(self, oBase, task, cal):
        self.oBase = oBase
        self.task = task
        self.orig_cal = cal
        self.vBox = gtk.VBox(homogeneous=False, spacing=0)
        
        hBox1 = gtk.HBox()
        labelSum = gtk.Label()
        labelSum.set_text("Summary")
        self.entrySum = gtk.Entry()
        #entrySum.set_text(...)
        hBox1.pack_start(child=labelSum, expand=False, fill=True, padding=8)
        hBox1.pack_start(child=self.entrySum, expand=True, fill=True, padding=8)
        hBox2 = gtk.HBox()
        labelCat = gtk.Label()
        labelCat.set_text("Categorie")
        self.cbxCat = gtk.ComboBox()
        self.listCat = gtk.ListStore(str)
        self.cbxCat.set_model(self.listCat)
        cel_text = gtk.CellRendererText()
        
        self.cbxCat.pack_start(cel_text, True)
        self.cbxCat.add_attribute(cel_text,'text',0)
        
        labelCal = gtk.Label()
        labelCal.set_text("Calendar")
        self.cbxCal = gtk.ComboBox()
        self.listCal = gtk.ListStore(str, object)
        self.cbxCal.set_model(self.listCal)
        
        self.cbxCal.pack_start(cel_text, True)
        self.cbxCal.add_attribute(cel_text,'text',0)
        
        
        hBox2.pack_start(child=labelCat, expand=False, fill=True, padding=8)
        hBox2.pack_start(child=self.cbxCat, expand=True, fill=True, padding=8)
        hBox2.pack_start(child=labelCal, expand=False, fill=True, padding=8)
        hBox2.pack_start(child=self.cbxCal, expand=True, fill=True, padding=8)
        hBox3 = gtk.HBox()
        
        labelStart = gtk.Label()
        labelStart.set_text("Start")
        self.entryStart = gtk.Entry()
        self.checkStart = gtk.CheckButton()
        self.checkStart.set_active(False)
        self.btnStart = gtk.Button()
        imgStart = gtk.Image()
        imgStart.set_from_stock(gtk.STOCK_EDIT,4)
        self.btnStart.add(imgStart)
        self.spbStartH = gtk.SpinButton()
        self.spbStartH.set_range(0,23)
        self.spbStartH.set_wrap(True)
        self.spbStartH.set_increments(1, 1)
        self.spbStartM = gtk.SpinButton()
        self.spbStartM.set_range(0,59)
        self.spbStartM.set_wrap(True)
        self.spbStartM.set_increments(5, 1)
        
        labelDue = gtk.Label()
        labelDue.set_text("Due")
        self.entryDue = gtk.Entry()
        self.checkDue = gtk.CheckButton()
        self.checkDue.set_active(False)
        self.btnDue = gtk.Button()
        imgDue = gtk.Image()
        imgDue.set_from_stock(gtk.STOCK_EDIT,4)
        self.btnDue.add(imgDue)
        self.spbDueH = gtk.SpinButton()
        self.spbDueH.set_range(0,23)
        self.spbDueH.set_wrap(True)
        self.spbDueH.set_increments(1, 1)
        self.spbDueM = gtk.SpinButton()
        self.spbDueM.set_range(0,59)
        self.spbDueM.set_wrap(True)
        self.spbDueM.set_increments(5, 1)
        
        hBox3.pack_start(child=self.checkStart, expand=False, fill=True, padding=8)
        hBox3.pack_start(child=labelStart, expand=False, fill=True, padding=8)
        hBox3.pack_start(child=self.entryStart, expand=True, fill=True, padding=8)
        hBox3.pack_start(child=self.btnStart, expand=False, fill=True, padding=8)
        hBox3.pack_start(child=self.spbStartH, expand=False, fill=True, padding=8)
        hBox3.pack_start(child=self.spbStartM, expand=False, fill=True, padding=8)
        
        hBox3.pack_start(child=self.checkDue, expand=False, fill=True, padding=8)
        hBox3.pack_start(child=labelDue, expand=False, fill=True, padding=8)
        hBox3.pack_start(child=self.entryDue, expand=True, fill=True, padding=8)
        hBox3.pack_start(child=self.btnDue, expand=False, fill=True, padding=8)
        hBox3.pack_start(child=self.spbDueH, expand=False, fill=True, padding=8)
        hBox3.pack_start(child=self.spbDueM, expand=False, fill=True, padding=8)
        
        hBox4 = gtk.HBox()
        descLabel = gtk.Label()
        descLabel.set_text("Description")
        self.textView = gtk.TextView()
        self.textView.set_wrap_mode(gtk.WRAP_WORD)
        scrolledWindow = gtk.ScrolledWindow()
        scrolledWindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        scrolledWindow.add(self.textView)
        hBox4.pack_start(child=descLabel, expand=False, fill=False, padding=8)
        hBox4.pack_start(child=scrolledWindow, expand=True, fill=True, padding=8)
        
        hBox5 = gtk.HBox()
        
        percLabel = gtk.Label()
        percLabel.set_text("Percent")
        self.hScale = gtk.HScale()
        self.hScale.set_range(0,100)
        self.hScale.set_digits(0)
        prioLabel = gtk.Label()
        prioLabel.set_text("Priority")
        self.spbPrio = gtk.SpinButton()
        self.spbPrio.set_range(1,9)
        self.spbPrio.set_wrap(False)
        self.spbPrio.set_increments(1, 1)
        hBox5.pack_start(child=percLabel, expand=False, fill=False, padding=8)
        hBox5.pack_start(child=self.hScale, expand=True, fill=True, padding=8)
        hBox5.pack_start(child=prioLabel, expand=False, fill=False, padding=8)
        hBox5.pack_start(child=self.spbPrio, expand=False, fill=True, padding=8)
        
        self.vBox.pack_start(child=hBox1 ,expand=False, fill=False, padding=8)
        self.vBox.pack_start(child=hBox2 ,expand=False, fill=False, padding=8)
        self.vBox.pack_start(child=hBox3 ,expand=False, fill=False, padding=8)
        self.vBox.pack_start(child=hBox4 ,expand=True, fill=True, padding=8)
        self.vBox.pack_start(child=hBox5 ,expand=False, fill=False, padding=8)
    
        self.entrySum.set_text(task["SUMMARY"])
        
        for cat in self.oBase.oConf.categories.keys():
            if cat == self.task["CATEGORIES"]:
                self.listCat.insert(0,[cat])
                self.cbxCat.set_active(0)
            else:    
                self.listCat.append([cat])
        
        
        for dcal in self.oBase.oConf.calendars.values():
            if dcal.name == self.orig_cal.name:
                self.listCal.insert(0,[dcal.name,dcal])
            else:
                self.listCal.append([dcal.name,dcal])
        self.cbxCal.set_active(0)
    
        self.spbPrio.set_value(int(self.task['PRIORITY']))
        
        if self.task.has_key('dtstart'):
            self.checkStart.set_active(True)
        #    #self.entryStart.set_text(vDatetime.from_ical(self.task['DTSTART']).strftime("%d/%m/%Y"))
        #    self.entryStart.set_text(self.task.decoded('dtstart').strftime("%d/%m/%Y"))
        #    self.spbStartH.set_value(int(self.task.decoded('dtstart').strftime("%H")))
        #    self.spbStartM.set_value(int(self.task.decoded('dtstart').strftime("%M")))
        if self.task.has_key('due'):
            self.checkDue.set_active(True)
        #    self.entryDue.set_text(self.task.decoded('due').strftime("%d/%m/%Y"))
        #    self.spbDueH.set_value(int(self.task.decoded('due').strftime("%H")))
        #    self.spbDueM.set_value(int(self.task.decoded('due').strftime("%M")))
        self.checkDateToggled(self.checkStart)            
        self.checkDateToggled(self.checkDue)
        
        self.textView.get_buffer().set_text(self.task['DESCRIPTION'])    
        self.hScale.set_value(int(self.task['PERCENT-COMPLETE']))
        
        self.btnStart.connect("clicked", self.btn_dateChooser)
        self.btnDue.connect("clicked", self.btn_dateChooser)
        self.checkStart.connect("toggled", self.checkDateToggled)
        self.checkDue.connect("toggled", self.checkDateToggled)
    
    def apply_changes(self):
        self.task['SUMMARY'] = self.entrySum.get_text()
    	self.task['CATEGORIES'] = self.cbxCat.get_model()[self.cbxCat.get_active()][0]
    	self.task['PRIORITY'] = self.spbPrio.get_text()
    
        start, end = self.textView.get_buffer().get_bounds()
    	self.task['DESCRIPTION'] = vText(self.textView.get_buffer().get_slice(start, end, True))
    	
    	# chaine de caractere => datetime => Vdatetime
        if self.checkStart.get_active():
            ch=self.entryStart.get_text()
            dt=datetime(int(ch[6:10]), int(ch[3:5]), int(ch[0:2]), int(self.spbStartH.get_value()), int(self.spbStartM.get_value()),0)
            #vdt=vDatetime(self.task['DTSTART'])
            #vdt=vDatetime(dt)
            self.task['DTSTART'] = vDatetime(dt).ical()
        elif self.task.has_key('dtstart'):
            del self.task['dtstart']
            
        if self.checkDue.get_active():
            ch=self.entryDue.get_text()
            dt=datetime(int(ch[6:10]), int(ch[3:5]), int(ch[0:2]), int(self.spbDueH.get_value()), int(self.spbDueM.get_value()),0)
            #vdt=vDatetime(self.task['DUE'])
            #vdt=vDatetime(dt)
            self.task['DUE'] = vDatetime(dt).ical()
        elif self.task.has_key('due'):
            del self.task['due']
        

##	if self.bcompleted.get_active():
##            self.task['STATUS'] = "COMPLETED"
##        else:
##        if self.bcancelled.get_active():
##            self.task['STATUS'] = "CANCELLED"
##        else:
    #    if self.wPercent.get_value() == 0:
    #        self.task['STATUS'] = "NEEDS-ACTION"
     #   else:
    #        self.task['STATUS'] = "IN-PROCESS"
		
        self.task['PERCENT-COMPLETE'] = int(self.hScale.get_value())
       
        new_calend = self.cbxCal.get_model()[self.cbxCal.get_active()][1]
        if new_calend <> self.orig_cal:
            print new_calend.filename, self.orig_cal.filename
            print "Calendrier chang"
            new_calend.cal.add_component(self.task)
            
            i = 0    
            for component in self.orig_cal.cal.subcomponents:
                if component == self.task:
                    del self.orig_cal.cal.subcomponents[i]
                    break
                i += 1      
        self.oBase.redisplay_selected_calendars()    
    
    def btn_dateChooser(self, data):
        print data
        self.diagcal = gtk.Dialog(None,None,gtk.DIALOG_MODAL)
        self.diagcal.set_transient_for(self.container)
        calend = gtk.Calendar()
        self.diagcal.vbox.add(calend)
        self.diagcal.show_all()
        calend.connect("day-selected", self.calend_day_selected)
        
    def calend_day_selected(self,wid):
        print wid.get_date()
        self.diagcal.destroy()

    def checkDateToggled(self, button):
        state = button.get_active()
        if button == self.checkDue:
            self.entryDue.set_sensitive(state)
            self.btnDue.set_sensitive(state)
            self.spbDueH.set_sensitive(state)
            self.spbDueM.set_sensitive(state)
            if state:
                if self.task.has_key('due'):
                    self.entryDue.set_text(self.task.decoded('due').strftime("%d/%m/%Y"))
                    self.spbDueH.set_value(int(self.task.decoded('due').strftime("%H")))
                    self.spbDueM.set_value(int(self.task.decoded('due').strftime("%M")))
                else:
                    self.entryDue.set_text(datetime.today().strftime("%d/%m/%Y"))
                    self.spbDueH.set_value(int(datetime.today().strftime("%H")))
                    self.spbDueM.set_value(int(datetime.today().strftime("%M")))
        elif button == self.checkStart:
            self.entryStart.set_sensitive(state)
            self.btnStart.set_sensitive(state)
            self.spbStartH.set_sensitive(state)
            self.spbStartM.set_sensitive(state)
            if state:
                if self.task.has_key('dtstart'):
                    self.entryStart.set_text(self.task.decoded('dtstart').strftime("%d/%m/%Y"))
                    self.spbStartH.set_value(int(self.task.decoded('dtstart').strftime("%H")))
                    self.spbStartM.set_value(int(self.task.decoded('dtstart').strftime("%M")))
                else:
                    self.entryStart.set_text(datetime.today().strftime("%d/%m/%Y"))
                    self.spbStartH.set_value(int(datetime.today().strftime("%H")))
                    self.spbStartM.set_value(int(datetime.today().strftime("%M")))

class ogzFrameTask (ogzEditTask) :
    def __init__(self,  oBase):
        self.oBase = oBase
        self.container = gtk.Frame()
        
            
class ogzDialogTask (ogzEditTask ):
    def __init__(self, oBase, task,cal):
        self.oBase = oBase
        self.task = task
        self.orig_cal = cal
        self.container = gtk.Dialog("Task",None,gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT)
       
        del_button = self.container.add_button(gtk.STOCK_DELETE, -99)    
        cancel_button = self.container.add_button(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL)
        ok_button = self.container.add_button(gtk.STOCK_OK, gtk.RESPONSE_OK)
        sep = gtk.VSeparator()
        self.container.action_area.pack_start(child=sep ,expand=False, fill=False, padding=4)
        #self.container.action_area.set_child_packing(del_button,False,False,20,gtk.PACK_START)
        self.container.set_default_size(250,250)
        self.container.set_size_request(700,400)
        ogzEditTask.__init__(self, oBase, task,cal)
        self.container.vbox.pack_start(child=self.vBox, expand=True, fill=True, padding=8)
        self.container.action_area.reorder_child(child=sep , position = 1)
        self.container.show_all()
        response=self.container.run()
        if response == gtk.RESPONSE_OK:
            self.apply_changes()
        self.container.destroy()    
        
        
                 