# -*- coding: iso-8859-15 -*-

import pygtk
pygtk.require('2.0')
import gtk
#import gobject

from datetime import *
from icalendar import vDatetime

class ogzFramePreview:

    def __init__(self, oWin):
        self.oWin = oWin
        self.frame = gtk.Frame()
        self.scrolledWindow = gtk.ScrolledWindow()
        self.scrolledWindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.textView = gtk.TextView()
        self.textBuffer = gtk.TextBuffer()
        self.textView.set_buffer(self.textBuffer)
        self.textView.set_wrap_mode(gtk.WRAP_WORD)
        self.textView.set_editable(False)
        self.scrolledWindow.add(self.textView)
        self.frame.add(self.scrolledWindow)
        
    def preview(self, elementToPreview):  
        self.elem = elementToPreview
        self.textBuffer.set_text(self.elem["SUMMARY"])
        self.textBuffer.insert_at_cursor("\n\nDescription : " + self.elem["DESCRIPTION"])
        if  self.elem.has_key('due'):
            self.textBuffer.insert_at_cursor("\n\nDue date : " + self.elem.decoded('due').strftime("%d/%m/%Y"))
        self.textBuffer.insert_at_cursor("\n\nPercente Complete : " + str(self.elem["PERCENT-COMPLETE"]))
        self.textBuffer.insert_at_cursor("\n\nCategories : " + self.elem["CATEGORIES"])