# -*- coding: iso-8859-15 -*-

import pygtk
pygtk.require('2.0')
import gtk
from datetime import *
from ogzUIDGenerator import UIDGenerator

from icalendar import vDatetime

def correctICalTodo(todo):
    try:
        resum = todo['SUMMARY']
    except KeyError:
        resum = "Unknown"
        todo['SUMMARY'] = resum
        
    try:
        uid = todo['UID']
    except KeyError:
        g = UIDGenerator()
        uid = g.uid()
        todo['UID'] = uid.ical()
    
    if uid == 'a42':   # petit fix pour remettre les id bien
        g = UIDGenerator()
        uid = g.uid()
        todo['UID'] = uid.ical()
    
    try:
        descr = todo['DESCRIPTION']
    except:
        descr = ''
        todo['DESCRIPTION'] = descr
        
    try:
        prio = todo['PRIORITY']
    except:
        prio = '5'
        todo['PRIORITY'] = prio
    
    try:
        date = todo['DUE']
    except KeyError:
        #todo['DUE'] = vDatetime(datetime.today()).ical()
        pass
    try:
        date = todo['DTSTART']
    except KeyError:
        #todo['DTSTART'] = vDatetime(datetime.today()).ical() 
        pass

    try:
        percent = todo['PERCENT-COMPLETE']
    except:
        todo['PERCENT-COMPLETE'] = '0'

    try:
        cat = todo['CATEGORIES']
    except KeyError:
        todo['CATEGORIES'] = ''
    
    check = False    
    try:
        if todo['STATUS'] == 'COMPLETED' or todo['STATUS'] == 'CANCELLED':
            resum = '<s>' + resum + '</s>'
            check = True
        else:
            #if vDatetime.from_ical(todo['DUE']) < datetime.today():
            #    resum ='<span foreground="red">' + resum + '</span>'
            #elif vDatetime.from_ical(todo['DTSTART']) > datetime.today():
            #    resum ='<span foreground="blue">' + resum + '</span>'
            if prio < '3':
                resum = '<b>' + resum + '</b>'
    except:
        todo['STATUS']= ''
  
    return todo    
